#ifndef _LINUX_L2TP_H
#define _LINUX_L2TP_H

#ifdef __cplusplus
extern "C" {
#endif

#include <linux/types.h>

enum {
	L2TP_CMD_NOOP,
	L2TP_CMD_TUNNEL_CREATE,
	L2TP_CMD_TUNNEL_DELETE,
	L2TP_CMD_TUNNEL_MODIFY,
	L2TP_CMD_TUNNEL_GET,
	L2TP_CMD_SESSION_CREATE,
	L2TP_CMD_SESSION_DELETE,
	L2TP_CMD_SESSION_MODIFY,
	L2TP_CMD_SESSION_GET,
	__L2TP_CMD_MAX,
};

#define L2TP_CMD_MAX (__L2TP_CMD_MAX - 1)

enum {
	L2TP_ATTR_NONE,
	L2TP_ATTR_PW_TYPE,
	L2TP_ATTR_ENCAP_TYPE,
	L2TP_ATTR_OFFSET,
	L2TP_ATTR_DATA_SEQ,
	L2TP_ATTR_L2SPEC_TYPE,
	L2TP_ATTR_L2SPEC_LEN,
	L2TP_ATTR_PROTO_VERSION,
	L2TP_ATTR_IFNAME,
	L2TP_ATTR_CONN_ID,
	L2TP_ATTR_PEER_CONN_ID,
	L2TP_ATTR_SESSION_ID,
	L2TP_ATTR_PEER_SESSION_ID,
	L2TP_ATTR_UDP_CSUM,
	L2TP_ATTR_VLAN_ID,
	L2TP_ATTR_COOKIE,
	L2TP_ATTR_PEER_COOKIE,
	L2TP_ATTR_DEBUG,
	L2TP_ATTR_RECV_SEQ,
	L2TP_ATTR_SEND_SEQ,
	L2TP_ATTR_LNS_MODE,
	L2TP_ATTR_USING_IPSEC,
	L2TP_ATTR_RECV_TIMEOUT,
	L2TP_ATTR_FD,
	L2TP_ATTR_IP_SADDR,
	L2TP_ATTR_IP_DADDR,
	L2TP_ATTR_UDP_SPORT,
	L2TP_ATTR_UDP_DPORT,
	L2TP_ATTR_MTU,
	L2TP_ATTR_MRU,
	L2TP_ATTR_STATS,
	L2TP_ATTR_IP6_SADDR,
	L2TP_ATTR_IP6_DADDR,
	L2TP_ATTR_UDP_ZERO_CSUM6_TX,
	L2TP_ATTR_UDP_ZERO_CSUM6_RX,
	L2TP_ATTR_PAD,
	__L2TP_ATTR_MAX,
};

#define L2TP_ATTR_MAX (__L2TP_ATTR_MAX - 1)

#ifdef __cplusplus
}
#endif

#endif
